package com.fr.plugin.seed.repository;

import com.fanruan.api.io.ResourceModuleKit;
import com.fr.io.base.provider.RepositoryFactoryProvider;
import com.fr.io.fun.AbstractRepositoryFactoryProvider;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.seed.repository.core.SEEDRepositoryFactory;
import com.fr.plugin.transform.ExecuteFunctionRecord;
import com.fr.plugin.transform.FunctionRecorder;

/**
 * SEED, Shared Ensured External Directory共享外部目录
 * <p>
 * Created by rinoux on 2018-11-30.
 */
@FunctionRecorder
public class SEEDFactoryProvider extends AbstractRepositoryFactoryProvider {
    private static final SEEDRepositoryFactory FACTORY = new SEEDRepositoryFactory();

    static {
        try {
            ResourceModuleKit.addFactory(FACTORY);
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error("Add repository factory {} failed.", FACTORY.getIdentity());
        }
    }

    @Override
    @ExecuteFunctionRecord
    public RepositoryFactoryProvider getFactory() {
        return FACTORY;
    }
}
